//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TrackForm.h"
#include "TrackAbout.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VWTrackMouse"
#pragma resource "*.dfm"
TFormDemo *FormDemo;
//---------------------------------------------------------------------------
__fastcall TFormDemo::TFormDemo(TComponent* Owner) : TForm(Owner) {}
//---------------------------------------------------------------------------

void __fastcall TFormDemo::VWTrackMouseEnter(TObject *Sender) {
     if( AnsiString(((TControl *) Sender)->ClassName()) == "TLabel" ) {
          ((TLabel *)Sender)->Font->Style = ((TLabel *)Sender)->Font->Style << fsUnderline << fsBold;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TEdit" ) {
          ((TEdit *) Sender)->Color = clSilver;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TButton" ) {
          ((TButton *) Sender)->Font->Style = ((TButton *) Sender)->Font->Style << fsUnderline << fsBold;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TCheckBox" ) {
          ((TCheckBox *) Sender)->Checked    = ! ((TCheckBox *) Sender)->Checked;
          ((TCheckBox *) Sender)->Font->Color = clWhite;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TBevel" ) {
          ((TBevel *) Sender)->Style = bsRaised;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TRadioButton" ) {
          ((TRadioButton *) Sender)->Font->Style = ((TRadioButton *) Sender)->Font->Style << fsBold;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TFormDemo" ) {
          //((TForm *) Sender)->Font->Style = ((TForm *) Sender)->Font->Style << fsBold;
     }
     else {
          ((TPanel *) Sender)->Color      = clAqua;
          ((TPanel *) Sender)->Font->Color = clBlack;
          ((TPanel *) Sender)->BevelOuter = bvRaised;
     }
     lblAdditioned->Caption = "Controls Additioned: " + AnsiString(VWTrack->Controls->Count);
}
//---------------------------------------------------------------------------
void __fastcall TFormDemo::VWTrackMouseLeave(TObject *Sender) {
     if( AnsiString(((TControl *) Sender)->ClassName()) == "TLabel" ) {
          ((TLabel *)Sender)->Font->Style = (((TLabel *)Sender)->Font->Style << fsBold) >> fsUnderline;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TEdit" ) {
          ((TEdit *) Sender)->Color = clGray;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TButton" ) {
          ((TButton *) Sender)->Font->Style = ((TButton *) Sender)->Font->Style >> fsUnderline >> fsBold;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TCheckBox" ) {
          ((TCheckBox *) Sender)->Checked    = ! ((TCheckBox *) Sender)->Checked;
          ((TCheckBox *) Sender)->Font->Color = clSilver;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TBevel" ) {
          ((TBevel *) Sender)->Style = bsLowered;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TRadioButton" ) {
          ((TRadioButton *) Sender)->Font->Style = ((TRadioButton *) Sender)->Font->Style >> fsBold;
     }
     else if( AnsiString(((TControl *) Sender)->ClassName()) == "TFormDemo" ) {
          //((TForm *) Sender)->Font->Style = ((TForm *) Sender)->Font->Style << fsBold;
     }
     else {
          ((TPanel *) Sender)->Color       = (Graphics::TColor) 0x414141;
          ((TPanel *) Sender)->Font->Color = clWhite;
          ((TPanel *) Sender)->BevelOuter  = bvNone;
     }
     lblAdditioned->Caption = "Controls Additioned: " + AnsiString(VWTrack->Controls->Count);
}
//---------------------------------------------------------------------------
void __fastcall TFormDemo::pnlPanelsMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y) {
     ((TPanel *)Sender)->BevelOuter = bvLowered;
}
//---------------------------------------------------------------------------
void __fastcall TFormDemo::pnlPanelsMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y) {
     ((TPanel *)Sender)->BevelOuter = bvRaised;
     if( ((TPanel *)Sender)->Caption == "Exit" )
          Close();
     else if( ((TPanel *)Sender)->Caption == "About" )
          FormAbout->ShowModal();
     else if( ((TPanel *)Sender)->Caption == "Add" ) {
          pnlPanels->Visible = true;
          if( VWTrack->Controls->IndexOf( pnlPanels ) != -1 )
               MessageBox( NULL, "The control \"pnlPanels\" is already additioned.", "Adding Control", (MB_ICONERROR | MB_OK) );
          else
               VWTrack->Controls->Add( pnlPanels );
     }
     else if( ((TPanel *)Sender)->Caption == "Remove" ) {
          pnlPanels->Visible = false;
          if( VWTrack->Controls->Remove( pnlPanels ) == -1 )
               MessageBox( NULL, "The control \"pnlPanels\" haven't been additioned.", "Removing Control", (MB_ICONERROR | MB_OK) );
     }
}
//---------------------------------------------------------------------------

void __fastcall TFormDemo::chkboxBoundingClick(TObject *Sender) {
     VWTrack->Bounding = chkboxBounding->Checked;
     FormAbout->VWTrackAbout->Bounding = chkboxBounding->Checked;
}
//---------------------------------------------------------------------------

